Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 3625)
@@ -10,22 +10,23 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                    LIM3 sea-ice model
+   !!   'key_lim3'                                      LIM-3 sea-ice model
    !!----------------------------------------------------------------------
-   USE par_oce          ! ocean parameters
-   USE dom_oce          ! ocean domain
-   USE phycst           ! physical constants (ocean directory) 
-   USE sbc_oce          ! surface boundary condition: ocean fields
-   USE thd_ice          ! LIM thermodynamics
-   USE ice              ! LIM variables
-   USE par_ice          ! LIM parameters
-   USE dom_ice          ! LIM domain
-   USE limthd_lac       ! LIM
-   USE limvar           ! LIM
-   USE limcons          ! LIM
-   USE in_out_manager   ! I/O manager
-   USE lbclnk           ! lateral boundary condition - MPP exchanges
-   USE lib_mpp          ! MPP library
-   USE wrk_nemo         ! work arrays
-   USE prtctl           ! Print control
+   USE par_oce        ! ocean parameters
+   USE dom_oce        ! ocean domain
+   USE phycst         ! physical constants (ocean directory) 
+   USE sbc_oce        ! surface boundary condition: ocean fields
+   USE thd_ice        ! LIM thermodynamics
+   USE ice            ! LIM variables
+   USE par_ice        ! LIM parameters
+   USE dom_ice        ! LIM domain
+   USE limthd_lac     ! LIM
+   USE limvar         ! LIM
+   USE limcons        ! LIM
+   USE in_out_manager ! I/O manager
+   USE lbclnk         ! lateral boundary condition - MPP exchanges
+   USE lib_mpp        ! MPP library
+   USE wrk_nemo       ! work arrays
+   USE prtctl         ! Print control
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -38,7 +39,7 @@
    PUBLIC   lim_itd_me_alloc        ! called by iceini.F90
 
-   REAL(wp)  ::   epsi11 = 1.e-11_wp   ! constant values
-   REAL(wp)  ::   epsi10 = 1.e-10_wp   ! constant values
-   REAL(wp)  ::   epsi06 = 1.e-06_wp   ! constant values
+   REAL(wp) ::   epsi11 = 1.e-11_wp   ! constant values
+   REAL(wp) ::   epsi10 = 1.e-10_wp   ! constant values
+   REAL(wp) ::   epsi06 = 1.e-06_wp   ! constant values
 
    !-----------------------------------------------------------------------
@@ -47,8 +48,8 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   asum     ! sum of total ice and open water area
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   aksum    ! ratio of area removed to area ridged
-
+   !
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   athorn   ! participation function; fraction of ridging/
    !                                                           !  closing associated w/ category n
-
+   !
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmin    ! minimum ridge thickness
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmax    ! maximum ridge thickness
@@ -70,4 +71,5 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   dvirdgdt   ! rate of ice volume ridged (m/s)
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   opening    ! rate of opening due to divergence/shear (1/s)
+   !
    !!----------------------------------------------------------------------
    !! NEMO/LIM3 3.3 , UCL - NEMO Consortium (2010)
@@ -126,7 +128,7 @@
       INTEGER ::   ji, jj, jk, jl   ! dummy loop index
       INTEGER ::   niter, nitermax = 20   ! local integer 
-      LOGICAL  ::   asum_error              ! flag for asum .ne. 1
-      INTEGER  ::   iterate_ridging         ! if true, repeat the ridging
-      REAL(wp) ::   w1, tmpfac, dti         ! local scalar
+      LOGICAL  ::   asum_error            ! flag for asum .ne. 1
+      INTEGER  ::   iterate_ridging       ! if true, repeat the ridging
+      REAL(wp) ::   w1, tmpfac            ! local scalar
       CHARACTER (len = 15) ::   fieldid
       REAL(wp), POINTER, DIMENSION(:,:) ::   closing_net     ! net rate at which area is removed    (1/s)
@@ -152,12 +154,12 @@
       ! 1) Thickness categories boundaries, ice / o.w. concentrations, init_ons
       !-----------------------------------------------------------------------------!
-      ! Set hi_max(ncat) to a big value to ensure that all ridged ice 
-      ! is thinner than hi_max(ncat).
+      ! Set hi_max(ncat) to a big value to ensure that all ridged ice is thinner than hi_max(ncat).
 
       hi_max(jpl) = 999.99
 
-      Cp = 0.5 * grav * (rau0-rhoic) * rhoic / rau0      ! proport const for PE
-      CALL lim_itd_me_ridgeprep ! prepare ridging
-
+      Cp = 0.5 * grav * (rau0-rhoic) * rhoic / rau0                ! proport const for PE
+      !
+      CALL lim_itd_me_ridgeprep                                    ! prepare ridging
+      !
       IF( con_i)   CALL lim_column_sum( jpl, v_i, vt_i_init )      ! conservation check
 
@@ -166,8 +168,8 @@
             msnow_mlt(ji,jj) = 0._wp
             esnow_mlt(ji,jj) = 0._wp
-            dardg1dt (ji,jj)  = 0._wp
-            dardg2dt (ji,jj)  = 0._wp
-            dvirdgdt (ji,jj)  = 0._wp
-            opening  (ji,jj)  = 0._wp
+            dardg1dt (ji,jj) = 0._wp
+            dardg2dt (ji,jj) = 0._wp
+            dvirdgdt (ji,jj) = 0._wp
+            opening  (ji,jj) = 0._wp
 
             !-----------------------------------------------------------------------------!
@@ -201,5 +203,5 @@
             ! to give asum = 1.0 after ridging.
 
-            divu_adv(ji,jj) = ( 1._wp - asum(ji,jj) ) / rdt_ice  ! asum found in ridgeprep
+            divu_adv(ji,jj) = ( 1._wp - asum(ji,jj) ) * r1_rdtice  ! asum found in ridgeprep
 
             IF( divu_adv(ji,jj) < 0._wp )   closing_net(ji,jj) = MAX( closing_net(ji,jj), -divu_adv(ji,jj) )
@@ -207,6 +209,5 @@
             ! 2.3 opning
             !------------
-            ! Compute the (non-negative) opening rate that will give 
-            ! asum = 1.0 after ridging.
+            ! Compute the (non-negative) opening rate that will give asum = 1.0 after ridging.
             opning(ji,jj) = closing_net(ji,jj) + divu_adv(ji,jj)
          END DO
@@ -257,5 +258,5 @@
                   IF ( a_i(ji,jj,jl) > epsi11 .AND. athorn(ji,jj,jl) > 0._wp )THEN
                      w1 = athorn(ji,jj,jl) * closing_gross(ji,jj) * rdt_ice
-                     IF ( w1 > a_i(ji,jj,jl) ) THEN
+                     IF ( w1  >  a_i(ji,jj,jl) ) THEN
                         tmpfac = a_i(ji,jj,jl) / w1
                         closing_gross(ji,jj) = closing_gross(ji,jj) * tmpfac
@@ -291,5 +292,5 @@
                ELSE
                   iterate_ridging    = 1
-                  divu_adv   (ji,jj) = (1._wp - asum(ji,jj)) / rdt_ice
+                  divu_adv   (ji,jj) = (1._wp - asum(ji,jj)) * r1_rdtice
                   closing_net(ji,jj) = MAX( 0._wp, -divu_adv(ji,jj) )
                   opning     (ji,jj) = MAX( 0._wp,  divu_adv(ji,jj) )
@@ -308,5 +309,5 @@
 
          IF( iterate_ridging == 1 ) THEN
-            IF( niter .GT. nitermax ) THEN
+            IF( niter  >  nitermax ) THEN
                WRITE(numout,*) ' ALERTE : non-converging ridging scheme '
                WRITE(numout,*) ' niter, iterate_ridging ', niter, iterate_ridging
@@ -323,6 +324,4 @@
       ! Update fresh water and heat fluxes due to snow melt.
 
-      dti = 1._wp / rdt_ice
-
       asum_error = .false. 
 
@@ -330,16 +329,16 @@
          DO ji = 1, jpi
 
-            IF (ABS(asum(ji,jj) - 1.0) .GT. epsi11) asum_error = .true.
-
-            dardg1dt(ji,jj) = dardg1dt(ji,jj) * dti
-            dardg2dt(ji,jj) = dardg2dt(ji,jj) * dti
-            dvirdgdt(ji,jj) = dvirdgdt(ji,jj) * dti
-            opening (ji,jj) = opening (ji,jj) * dti
+            IF( ABS( asum(ji,jj) - 1.0 ) > epsi11 )   asum_error = .true.
+
+            dardg1dt(ji,jj) = dardg1dt(ji,jj) * r1_rdtice
+            dardg2dt(ji,jj) = dardg2dt(ji,jj) * r1_rdtice
+            dvirdgdt(ji,jj) = dvirdgdt(ji,jj) * r1_rdtice
+            opening (ji,jj) = opening (ji,jj) * r1_rdtice
 
             !-----------------------------------------------------------------------------!
             ! 5) Heat, salt and freshwater fluxes
             !-----------------------------------------------------------------------------!
-            fmmec(ji,jj) = fmmec(ji,jj) + msnow_mlt(ji,jj) * dti     ! fresh water source for ocean
-            fhmec(ji,jj) = fhmec(ji,jj) + esnow_mlt(ji,jj) * dti     ! heat sink for ocean
+            fmmec(ji,jj) = fmmec(ji,jj) + msnow_mlt(ji,jj) * r1_rdtice     ! fresh water source for ocean
+            fhmec(ji,jj) = fhmec(ji,jj) + esnow_mlt(ji,jj) * r1_rdtice     ! heat sink for ocean
 
          END DO
@@ -349,5 +348,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF (ABS(asum(ji,jj) - 1.0) .GT. epsi11) THEN ! there is a bug
+            IF( ABS( asum(ji,jj) - 1._wp )  >  epsi11 ) THEN   ! there is a bug
                WRITE(numout,*) ' '
                WRITE(numout,*) ' ALERTE : Ridging error: total area = ', asum(ji,jj)
@@ -391,5 +390,5 @@
       d_oa_i_trp (:,:,:)   = oa_i (:,:,:)   - old_oa_i (:,:,:)
       d_smv_i_trp(:,:,:)   = 0._wp
-      IF(  num_sal == 2  .OR.  num_sal == 4  )   d_smv_i_trp(:,:,:)  = smv_i(:,:,:) - old_smv_i(:,:,:)
+      IF(  num_sal == 2  )   d_smv_i_trp(:,:,:)  = smv_i(:,:,:) - old_smv_i(:,:,:)
 
       IF(ln_ctl) THEN     ! Control print
@@ -430,13 +429,13 @@
 
       ! update of fields will be made later in lim update
-      u_ice(:,:)    = old_u_ice(:,:)
-      v_ice(:,:)    = old_v_ice(:,:)
-      a_i(:,:,:)    = old_a_i(:,:,:)
-      v_s(:,:,:)    = old_v_s(:,:,:)
-      v_i(:,:,:)    = old_v_i(:,:,:)
-      e_s(:,:,:,:)  = old_e_s(:,:,:,:)
-      e_i(:,:,:,:)  = old_e_i(:,:,:,:)
-      oa_i(:,:,:)   = old_oa_i(:,:,:)
-      IF(  num_sal == 2  .OR.  num_sal == 4  )   smv_i(:,:,:)  = old_smv_i(:,:,:)
+      u_ice(:,:)   = old_u_ice(:,:)
+      v_ice(:,:)   = old_v_ice(:,:)
+      a_i(:,:,:)   = old_a_i(:,:,:)
+      v_s(:,:,:)   = old_v_s(:,:,:)
+      v_i(:,:,:)   = old_v_i(:,:,:)
+      e_s(:,:,:,:) = old_e_s(:,:,:,:)
+      e_i(:,:,:,:) = old_e_i(:,:,:,:)
+      oa_i(:,:,:)  = old_oa_i(:,:,:)
+      IF(  num_sal == 2  )   smv_i(:,:,:) = old_smv_i(:,:,:)
 
       !----------------------------------------------------!
@@ -465,23 +464,23 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF ( ( old_v_i(ji,jj,jl) < epsi06 ) .AND. &
-                  ( d_v_i_trp(ji,jj,jl) > epsi06 ) ) THEN
-                  old_v_i(ji,jj,jl)     = d_v_i_trp(ji,jj,jl)
-                  d_v_i_trp(ji,jj,jl)   = 0._wp
-                  old_a_i(ji,jj,jl)     = d_a_i_trp(ji,jj,jl)
-                  d_a_i_trp(ji,jj,jl)   = 0._wp
-                  old_v_s(ji,jj,jl)     = d_v_s_trp(ji,jj,jl)
-                  d_v_s_trp(ji,jj,jl)   = 0._wp
-                  old_e_s(ji,jj,1,jl)   = d_e_s_trp(ji,jj,1,jl)
-                  d_e_s_trp(ji,jj,1,jl) = 0._wp
-                  old_oa_i(ji,jj,jl)    = d_oa_i_trp(ji,jj,jl)
-                  d_oa_i_trp(ji,jj,jl)  = 0._wp
-                  IF(  num_sal == 2  .OR.  num_sal == 4  )   old_smv_i(ji,jj,jl)   = d_smv_i_trp(ji,jj,jl)
-                  d_smv_i_trp(ji,jj,jl) = 0._wp
+               IF(  old_v_i  (ji,jj,jl) < epsi06  .AND. &
+                    d_v_i_trp(ji,jj,jl) > epsi06    ) THEN
+                  old_v_i   (ji,jj,jl)   = d_v_i_trp(ji,jj,jl)
+                  d_v_i_trp (ji,jj,jl)   = 0._wp
+                  old_a_i   (ji,jj,jl)   = d_a_i_trp(ji,jj,jl)
+                  d_a_i_trp (ji,jj,jl)   = 0._wp
+                  old_v_s   (ji,jj,jl)   = d_v_s_trp(ji,jj,jl)
+                  d_v_s_trp (ji,jj,jl)   = 0._wp
+                  old_e_s   (ji,jj,1,jl) = d_e_s_trp(ji,jj,1,jl)
+                  d_e_s_trp (ji,jj,1,jl) = 0._wp
+                  old_oa_i  (ji,jj,jl)   = d_oa_i_trp(ji,jj,jl)
+                  d_oa_i_trp(ji,jj,jl)   = 0._wp
+                  IF(  num_sal == 2  )   old_smv_i(ji,jj,jl) = d_smv_i_trp(ji,jj,jl)
+                  d_smv_i_trp(ji,jj,jl)  = 0._wp
                ENDIF
             END DO
          END DO
       END DO
-
+      !
       CALL wrk_dealloc( jpi, jpj, closing_net, divu_adv, opning, closing_gross, msnow_mlt, esnow_mlt, vt_i_init, vt_i_final )
       !
@@ -612,13 +611,13 @@
                   ! present
                   zworka(ji,jj) = 4.0 * strength(ji,jj)              &
-                     + strength(ji-1,jj) * tms(ji-1,jj) &  
-                     + strength(ji+1,jj) * tms(ji+1,jj) &  
-                     + strength(ji,jj-1) * tms(ji,jj-1) &  
-                     + strength(ji,jj+1) * tms(ji,jj+1)    
+                     &          + strength(ji-1,jj) * tms(ji-1,jj) &  
+                     &          + strength(ji+1,jj) * tms(ji+1,jj) &  
+                     &          + strength(ji,jj-1) * tms(ji,jj-1) &  
+                     &          + strength(ji,jj+1) * tms(ji,jj+1)    
 
                   zw1 = 4.0 + tms(ji-1,jj) + tms(ji+1,jj) + tms(ji,jj-1) + tms(ji,jj+1)
                   zworka(ji,jj) = zworka(ji,jj) / zw1
                ELSE
-                  zworka(ji,jj) = 0.0
+                  zworka(ji,jj) = 0._wp
                ENDIF
             END DO
@@ -1048,6 +1047,6 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF (aicen_init(ji,jj,jl1) .GT. epsi11 .AND. athorn(ji,jj,jl1) .GT. 0.0       &
-                  .AND. closing_gross(ji,jj) > 0.0) THEN
+               IF( aicen_init(ji,jj,jl1)  >  epsi11  .AND.  athorn(ji,jj,jl1)  >  0._wp       &
+                  .AND. closing_gross(ji,jj) > 0._wp ) THEN
                   icells = icells + 1
                   indxi(icells) = ji
@@ -1130,5 +1129,5 @@
             ! Salinity
             !-------------
-            smsw(ji,jj)  = sss_m(ji,jj) * vsw(ji,jj) * rhoic / rau0       ! salt content of water frozen in voids
+            smsw(ji,jj)  = sss_m(ji,jj) * vsw(ji,jj) * rhoic / rau0       ! salt content of seawater frozen in voids
 
             zsrdg2       = srdg1(ji,jj) + smsw(ji,jj)                     ! salt content of new ridge
@@ -1137,6 +1136,8 @@
             
             !                                                             ! excess of salt is flushed into the ocean
-            fsalt_rpo(ji,jj) = fsalt_rpo(ji,jj) + ( zsrdg2 - srdg2(ji,jj) ) * rhoic / rdt_ice
-
+            sfx_mec(ji,jj) = sfx_mec(ji,jj) + ( zsrdg2 - srdg2(ji,jj) ) * rhoic * r1_rdtice
+
+            rdm_ice(ji,jj) = rdm_ice(ji,jj) + vsw(ji,jj) * rhoic / rau0   ! increase in ice volume du to seawater frozen in voids
+            
             !------------------------------------            
             ! 3.6 Increment ridging diagnostics
@@ -1148,6 +1149,6 @@
             dardg1dt   (ji,jj) = dardg1dt(ji,jj) + ardg1(ji,jj) + arft1(ji,jj)
             dardg2dt   (ji,jj) = dardg2dt(ji,jj) + ardg2(ji,jj) + arft2(ji,jj)
-            diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( vrdg2(ji,jj) + virft(ji,jj) ) / rdt_ice
-            opening    (ji,jj) = opening (ji,jj) + opning(ji,jj)*rdt_ice
+            diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( vrdg2(ji,jj) + virft(ji,jj) ) * r1_rdtice
+            opening    (ji,jj) = opening (ji,jj) + opning(ji,jj) * rdt_ice
 
             IF( con_i )   vice_init(ji,jj) = vice_init(ji,jj) + vrdg2(ji,jj) - vrdg1(ji,jj)
@@ -1156,5 +1157,4 @@
             ! 3.7 Put the snow somewhere in the ocean
             !------------------------------------------            
-
             !  Place part of the snow lost by ridging into the ocean. 
             !  Note that esnow_mlt < 0; the ocean must cool to melt snow.
@@ -1179,7 +1179,6 @@
             !           ij looping 1-icells
 
-            dhr(ji,jj)  = hrmax(ji,jj,jl1) - hrmin(ji,jj,jl1)
+            dhr (ji,jj) = hrmax(ji,jj,jl1) - hrmin(ji,jj,jl1)
             dhr2(ji,jj) = hrmax(ji,jj,jl1) * hrmax(ji,jj,jl1) - hrmin(ji,jj,jl1) * hrmin(ji,jj,jl1)
-
 
          END DO                 ! ij
@@ -1211,5 +1210,5 @@
 
                ! heat flux
-               fheat_rpo(ji,jj) = fheat_rpo(ji,jj) + ( ersw(ji,jj,jk) - zdummy0 ) / rdt_ice
+               fheat_mec(ji,jj) = fheat_mec(ji,jj) + ( ersw(ji,jj,jk) - zdummy0 ) * r1_rdtice
 
                ! Correct dimensions to avoid big values
@@ -1275,23 +1274,23 @@
                ! Transfer area, volume, and energy accordingly.
 
-               IF (hrmin(ji,jj,jl1) .GE. hi_max(jl2) .OR.        &
-                  hrmax(ji,jj,jl1) .LE. hi_max(jl2-1)) THEN
-                  hL = 0.0
-                  hR = 0.0
+               IF( hrmin(ji,jj,jl1) >= hi_max(jl2)  .OR.        &
+                   hrmax(ji,jj,jl1) <= hi_max(jl2-1) ) THEN
+                  hL = 0._wp
+                  hR = 0._wp
                ELSE
-                  hL = MAX (hrmin(ji,jj,jl1), hi_max(jl2-1))
-                  hR = MIN (hrmax(ji,jj,jl1), hi_max(jl2))
+                  hL = MAX( hrmin(ji,jj,jl1), hi_max(jl2-1) )
+                  hR = MIN( hrmax(ji,jj,jl1), hi_max(jl2)   )
                ENDIF
 
                ! fraction of ridged ice area and volume going to n2
-               farea = (hR-hL) / dhr(ji,jj) 
-               fvol(ji,jj) = (hR*hR - hL*hL) / dhr2(ji,jj)
-
-               a_i  (ji,jj,jl2)   = a_i  (ji,jj,jl2)   + ardg2 (ji,jj) * farea
-               v_i  (ji,jj,jl2)   = v_i  (ji,jj,jl2)   + vrdg2 (ji,jj) * fvol(ji,jj)
-               v_s  (ji,jj,jl2)   = v_s  (ji,jj,jl2)   + vsrdg (ji,jj) * fvol(ji,jj) * fsnowrdg
+               farea = ( hR - hL ) / dhr(ji,jj) 
+               fvol(ji,jj) = ( hR*hR - hL*hL ) / dhr2(ji,jj)
+
+               a_i  (ji,jj  ,jl2) = a_i  (ji,jj  ,jl2) + ardg2 (ji,jj) * farea
+               v_i  (ji,jj  ,jl2) = v_i  (ji,jj  ,jl2) + vrdg2 (ji,jj) * fvol(ji,jj)
+               v_s  (ji,jj  ,jl2) = v_s  (ji,jj  ,jl2) + vsrdg (ji,jj) * fvol(ji,jj) * fsnowrdg
                e_s  (ji,jj,1,jl2) = e_s  (ji,jj,1,jl2) + esrdg (ji,jj) * fvol(ji,jj) * fsnowrdg
-               smv_i(ji,jj,jl2)   = smv_i(ji,jj,jl2)   + srdg2 (ji,jj) * fvol(ji,jj)
-               oa_i (ji,jj,jl2)   = oa_i (ji,jj,jl2)   + oirdg2(ji,jj) * farea
+               smv_i(ji,jj  ,jl2) = smv_i(ji,jj  ,jl2) + srdg2 (ji,jj) * fvol(ji,jj)
+               oa_i (ji,jj  ,jl2) = oa_i (ji,jj  ,jl2) + oirdg2(ji,jj) * farea
 
             END DO ! ij
@@ -1317,15 +1316,15 @@
                ! Compute the fraction of rafted ice area and volume going to 
                ! thickness category jl2, transfer area, volume, and energy accordingly.
-
-               IF (hraft(ji,jj,jl1) .LE. hi_max(jl2) .AND.        &
-                  hraft(ji,jj,jl1) .GT. hi_max(jl2-1)) THEN
-                  a_i(ji,jj,jl2) = a_i(ji,jj,jl2) + arft2(ji,jj)
-                  v_i(ji,jj,jl2) = v_i(ji,jj,jl2) + virft(ji,jj)
-                  v_s(ji,jj,jl2) = v_s(ji,jj,jl2) + vsrft(ji,jj)*fsnowrft
-                  e_s(ji,jj,1,jl2) = e_s(ji,jj,1,jl2) + esrft(ji,jj)*fsnowrft
-                  smv_i(ji,jj,jl2) = smv_i(ji,jj,jl2) + smrft(ji,jj)    
-                  oa_i(ji,jj,jl2)  = oa_i(ji,jj,jl2)  + oirft2(ji,jj)    
+               !
+               IF( hraft(ji,jj,jl1) <= hi_max(jl2)  .AND.        &
+                   hraft(ji,jj,jl1) >  hi_max(jl2-1) ) THEN
+                  a_i  (ji,jj  ,jl2) = a_i  (ji,jj  ,jl2) + arft2 (ji,jj)
+                  v_i  (ji,jj  ,jl2) = v_i  (ji,jj  ,jl2) + virft (ji,jj)
+                  v_s  (ji,jj  ,jl2) = v_s  (ji,jj  ,jl2) + vsrft (ji,jj) * fsnowrft
+                  e_s  (ji,jj,1,jl2) = e_s  (ji,jj,1,jl2) + esrft (ji,jj) * fsnowrft
+                  smv_i(ji,jj  ,jl2) = smv_i(ji,jj  ,jl2) + smrft (ji,jj)    
+                  oa_i (ji,jj  ,jl2) = oa_i (ji,jj  ,jl2) + oirft2(ji,jj)    
                ENDIF ! hraft
-
+               !
             END DO ! ij
 
@@ -1336,6 +1335,6 @@
                   ji = indxi(ij)
                   jj = indxj(ij)
-                  IF (hraft(ji,jj,jl1) .LE. hi_max(jl2) .AND.        &
-                     hraft(ji,jj,jl1) .GT. hi_max(jl2-1)) THEN
+                  IF(  hraft(ji,jj,jl1)  <=  hi_max(jl2)   .AND.        &
+                       hraft(ji,jj,jl1)  >   hi_max(jl2-1)  ) THEN
                      e_i(ji,jj,jk,jl2) = e_i(ji,jj,jk,jl2) + eirft(ji,jj,jk)
                   ENDIF
@@ -1504,5 +1503,5 @@
             DO jj = 1 , jpj
                DO ji = 1 , jpi
-!!gm                  xtmp = e_i(ji,jj,jk,jl) / area(ji,jj) / rdt_ice
+!!gm                  xtmp = e_i(ji,jj,jk,jl) / area(ji,jj) * r1_rdtice
 !!gm                  xtmp = xtmp * unit_fac
                   ! fheat_res(ji,jj) = fheat_res(ji,jj) - xtmp
@@ -1524,8 +1523,8 @@
                ! fluxes are positive to the ocean
                ! here the flux has to be negative for the ocean
-!!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) / rdt_ice
+!!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) * r1_rdtice
                !           fheat_res(ji,jj) = fheat_res(ji,jj) - xtmp
 
-!!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) / rdt_ice !RB   ???????
+!!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) * r1_rdtice !RB   ???????
 
                t_s(ji,jj,1,jl) = rtt * zmask(ji,jj) + t_s(ji,jj,1,jl) * ( 1 - zmask(ji,jj) )
@@ -1536,15 +1535,9 @@
 
                !           xtmp = (rhoi*vicen(i,j,n) + rhos*vsnon(i,j,n)) / dt
-               !           fresh(i,j)      = fresh(i,j)      + xtmp
-               !           fresh_hist(i,j) = fresh_hist(i,j) + xtmp
-
-               !           fsalt_res(ji,jj)  = fsalt_res(ji,jj) + ( sss_m(ji,jj)                  ) * & 
-               !                               rhosn * v_s(ji,jj,jl) / rdt_ice
-
-               !           fsalt_res(ji,jj)  = fsalt_res(ji,jj) + ( sss_m(ji,jj) - sm_i(ji,jj,jl) ) * & 
-               !                               rhoic * v_i(ji,jj,jl) / rdt_ice
-
-               !           emps(i,j)      = emps(i,j)      + xtmp
-               !           fsalt_hist(i,j) = fsalt_hist(i,j) + xtmp
+               !           sfx_res(ji,jj)  = sfx_res(ji,jj) + ( sss_m(ji,jj)                  )   &
+               !                                            * rhosn * v_s(ji,jj,jl) * r1_rdtice
+               !           sfx_res(ji,jj)  = sfx_res(ji,jj) + ( sss_m(ji,jj) - sm_i(ji,jj,jl) )   & 
+               !                                            * rhoic * v_i(ji,jj,jl) * r1_rdtice
+               !           sfx (i,j)      = sfx (i,j)      + xtmp
 
                ato_i(ji,jj)    = a_i  (ji,jj,jl) *       zmask(ji,jj)   + ato_i(ji,jj)
Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 3625)
@@ -2,6 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE limitd_th ***
-   !!              Thermodynamics of ice thickness distribution
-   !!                   computation of changes in g(h)      
+   !!   LIM3 ice model : ice thickness distribution: Thermodynamics
    !!======================================================================
    !! History :   -   !          (W. H. Lipscomb and E.C. Hunke) CICE (c) original code
@@ -20,18 +19,19 @@
    !!   lim_itd_shiftice :
    !!----------------------------------------------------------------------
-   USE dom_ice          ! LIM-3 domain
-   USE par_oce          ! ocean parameters
-   USE dom_oce          ! ocean domain
-   USE phycst           ! physical constants (ocean directory) 
-   USE thd_ice          ! LIM-3 thermodynamic variables
-   USE ice              ! LIM-3 variables
-   USE par_ice          ! LIM-3 parameters
-   USE limthd_lac       ! LIM-3 lateral accretion
-   USE limvar           ! LIM-3 variables
-   USE limcons          ! LIM-3 conservation
-   USE prtctl           ! Print control
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! MPP library
-   USE wrk_nemo         ! work arrays
+   USE par_oce        ! ocean parameters
+   USE dom_oce        ! ocean domain
+   USE phycst         ! physical constants (ocean directory) 
+   USE ice            ! LIM-3 variables
+   USE par_ice        ! LIM-3 parameters
+   USE dom_ice        ! LIM-3 domain
+   USE thd_ice        ! LIM-3 thermodynamic variables
+   USE limthd_lac     ! LIM-3 lateral accretion
+   USE limvar         ! LIM-3 variables
+   USE limcons        ! LIM-3 conservation
+   USE prtctl         ! Print control
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
+   USE wrk_nemo       ! work arrays
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -49,5 +49,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2010)
+   !! NEMO/LIM3 3.4 , UCL - NEMO Consortium (2010)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -101,12 +101,12 @@
 
       !- Trend terms
-      d_a_i_thd (:,:,:)  = a_i(:,:,:)   - old_a_i(:,:,:) 
-      d_v_s_thd (:,:,:)  = v_s(:,:,:)   - old_v_s(:,:,:)
-      d_v_i_thd (:,:,:)  = v_i(:,:,:)   - old_v_i(:,:,:)  
+      d_a_i_thd(:,:,:)   = a_i(:,:,:)   - old_a_i(:,:,:) 
+      d_v_s_thd(:,:,:)   = v_s(:,:,:)   - old_v_s(:,:,:)
+      d_v_i_thd(:,:,:)   = v_i(:,:,:)   - old_v_i(:,:,:)  
       d_e_s_thd(:,:,:,:) = e_s(:,:,:,:) - old_e_s(:,:,:,:) 
       d_e_i_thd(:,:,:,:) = e_i(:,:,:,:) - old_e_i(:,:,:,:)
 
       d_smv_i_thd(:,:,:) = 0._wp
-      IF( num_sal == 2 .OR. num_sal == 4 )   d_smv_i_thd(:,:,:) = smv_i(:,:,:) - old_smv_i(:,:,:)
+      IF( num_sal == 2  )   d_smv_i_thd(:,:,:) = smv_i(:,:,:) - old_smv_i(:,:,:)
 
       IF(ln_ctl) THEN   ! Control print
@@ -143,11 +143,11 @@
 
       !- Recover Old values
-      a_i(:,:,:)   = old_a_i (:,:,:)
-      v_s(:,:,:)   = old_v_s (:,:,:)
-      v_i(:,:,:)   = old_v_i (:,:,:)
-      e_s(:,:,:,:) = old_e_s (:,:,:,:)
-      e_i(:,:,:,:) = old_e_i (:,:,:,:)
-      !
-      IF( num_sal == 2 .OR. num_sal == 4 )   smv_i(:,:,:)       = old_smv_i (:,:,:)
+      a_i(:,:,:)   = old_a_i(:,:,:)
+      v_s(:,:,:)   = old_v_s(:,:,:)
+      v_i(:,:,:)   = old_v_i(:,:,:)
+      e_s(:,:,:,:) = old_e_s(:,:,:,:)
+      e_i(:,:,:,:) = old_e_i(:,:,:,:)
+      !
+      IF( num_sal == 2 )   smv_i(:,:,:) = old_smv_i(:,:,:)
       !
    END SUBROUTINE lim_itd_th
Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90	(revision 3625)
@@ -10,5 +10,5 @@
    !!   'key_lim3'                                      LIM3 sea-ice model
    !!----------------------------------------------------------------------
-   !!   lim_msh   : definition of the ice mesh
+   !!   lim_msh       : definition of the ice mesh
    !!----------------------------------------------------------------------
    USE phycst         ! physical constants
@@ -18,4 +18,5 @@
    USE lbclnk         ! lateral boundary condition - MPP exchanges
    USE lib_mpp        ! MPP library
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -25,5 +26,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/LIM3 3.4 , UCL - NEMO Consortium (2011)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
